/*
 * Copyright (C) 2010 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.android.rs.image;

import android.renderscript.*;
import android.content.res.Resources;
import android.util.Log;

public class ScriptC_Vertical_blur extends ScriptC {
    // Constructor
    public  ScriptC_Vertical_blur(RenderScript rs, Resources resources, int id, boolean isRoot) {
        super(rs, resources, id, isRoot);
    }

    private final static int mExportVarIdx_ScratchPixel = 0;
    private Allocation mExportVar_ScratchPixel;
    public void bind_ScratchPixel(Allocation v) {
        mExportVar_ScratchPixel = v;
        if(v == null) bindAllocation(null, mExportVarIdx_ScratchPixel);
        else bindAllocation(v, mExportVarIdx_ScratchPixel);
    }

    public Allocation get_ScratchPixel() {
        return mExportVar_ScratchPixel;
    }

}

